(*------------------------------------------------------------
TEAM05
A
177
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library DelphiSamplePlayer;
uses
  Math,
  Ants in 'Ants.pas';

const
  PLAYER_NAME = 'UdSU #1';

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;

function Event(p: Byte): Boolean;
begin
  result := Random(100) < p;
end;

const
  shift: array[0..3, 1..2] of Integer = ((1, 0), (0, -1), (-1, 0), (0, 1));
  diract: array[0..3] of TAntActionType = (aaMoveRight, aaMoveUp, aaMoveLeft, aaMoveDown);
  bitact: array[0..3] of TAntActionType = (aaBiteRight, aaBiteUp, aaBiteLeft, aaBiteDown);
  bitsmell = MaxInt - 997;
var
  i, j, sx, sy: Integer;
  number, state: Byte;
  dir: Integer;
  steps: Byte;
  bool: Boolean;
  ex, ey: Integer;
begin
  sx := Integer(memory^[0]) - 128;
  sy := Integer(memory^[1]) - 128;
  state := memory^[2];
  number := memory^[3];
  dir := memory^[4];
  ex := Integer(memory^[10]) - 128;
  ey := Integer(memory^[11]) - 128;

  if state = 0 then  // Unknown
  begin
    dir := 0;
    sx := 0;
    sy := 0;
    ex := 0;
    ey := 0;


    number := sensors[0, 0].smell + 1;
    result.putSmell := True;
    result.smell := number;

    case number of
    1, 2:
      begin
        Randomize;
        state := 1;
        memory^[5] := 1;
//        Sleep(5000);
      end;

      else state := 2;
    end;
  end;

  if (ex = 0) and (ey = 0) then
    for i := -1 to 1 do
      for j := -1 to 1 do
        if sensors[i, j].isFood and ((Abs(sx) > 2) or (ABs(sy) > 2)) then
        begin
          ex := sx + i;
          ey := sy + j;
        end;


  if (sx <> 0) and (sy <> 0) then
  begin
    result.putSmell := True;
    result.smell := Random(1000);
  end;

  bool := False;
  if (state <> 1) and (Sensors[-1, 0].isEnemy or Sensors[1, 0].isEnemy or Sensors[0, 1].isEnemy
      or Sensors[0, -1].isEnemy) then
  begin
    for i := 0 to 3 do
      if Sensors[shift[i, 1], shift[i, 2]].isEnemy then
      begin
        if Event(30 + 30 * Ord(not hasfood) * Ord((sensors[0, 0].smellIntensity < 94) and
            (sensors[0, 0].smell = bitsmell))) then
        begin
          result.actionType := bitact[i];
          result.putSmell := True;
          result.smell := BitSmell;
          bool := True;
          Break;
        end;
      end;
  end;

  if not bool then

  if not hasFood and sensors[0, 0].isEnemyHill and Event(80) and
    not sensors[0, 0].isFriend then
  begin
    Result.actionType := aaGet;
  end
  else if (state <> 1) and (sensors[0, 0].isFood) and ((Abs(sx) > 1) or (Abs(sy) > 1)) and not hasFood then
  begin
    Result.actionType := aaGet;
    State := 3;
  end
  else if (state = 1) and (sensors[0, 0].isFood) and (Sqr(sx) + Sqr(sy) > 0) and not hasFood then
  begin
    Result.actionType := aaGet;
  end
  else if hasFood and (sx = 0) and (sy = 0) then
  begin
    Result.actionType := aaPut;
    if state <> 1 then
      state := 2;
  end
  else if (state <> 1) and (sensors[-1, -1].isEnemy or sensors[-1, 1].isEnemy or
                            sensors[1, 1].isEnemy or sensors[1, -1].isEnemy) then
  begin
    while sensors[shift[dir, 1], shift[dir, 2]].isWall or Event(50) do
    begin
      if Event(35) then
        inc(Dir)
      else if Event(70) then
        Dec(dir)
      else
       Dec(dir, 2);

      if not sensors[shift[dir, 1], shift[dir, 2]].isWall then
        Break;

    end;
    result.actionType := diract[dir];
    sx := sx + shift[dir, 1];
    sy := sy + shift[dir, 2];
  end
  else
  begin
  case state of
    1: // 
      begin
//        sleep(1000);
        Steps := memory^[5];
        bool := False;

        for i := 0 to 3 do
        begin
          if sensors[shift[i, 1], shift[i, 2]].isEnemy and
            ((sensors[0, 0].smell = bitsmell) and (sensors[0, 0].smellIntensity < 94) or Event(70 div number)) then
          begin
            result.actionType := bitact[i];
            result.putSmell := True;
            result.smell := bitsmell;
            Bool := True;
            Break;
          end;
        end;

        if not bool then
        if number = 1 then
        begin
//          sleep(1000);
          while sensors[shift[dir, 1], shift[dir, 2]].isWall or (Steps > 1) do
          begin
            dir := dir + 1;
            if dir = 4 then
              dir := 0;
//              sleep(1000);
            Steps := 1;
          end;
          result.actionType := diract[dir];
          Inc(steps);
          Inc(sx, shift[dir, 1]);
          Inc(sy, shift[dir, 2]);
        end
        else if number = 2 then
        begin
          while sensors[shift[dir, 1], shift[dir, 2]].isWall or (Steps > 2) do
          begin
            dir := dir - 1;
            if dir = -1 then
              dir := 3;
            steps := 1;
          end;
          result.actionType := diract[dir];
          Inc(steps);
          Inc(sx, shift[dir, 1]);
          Inc(sy, shift[dir, 2]);
        end;

        memory^[5] := steps;
      end;

    2: //  
      begin
        if (sx = ex) and (sy = ey) then
        begin
          ex := 0;
          ey := 0;
        end;

        if Event(10) then
        begin
          ex := 0;
          ey := 0;
        end;

        if Event(90) and (ex <> 0) or (ey <> 0) then
        begin
          if Abs(ex - sx) < Abs(ey - sy) then
          begin
            if sy < ey then
              dir := 3
            else
              dir := 1;
          end
          else if sx < ex then
            dir := 0
          else
            dir := 2;

          result.actionType := diract[dir];
          Inc(sx, shift[dir, 1]);
          Inc(sy, shift[dir, 2]);
        end else
        begin

        while sensors[shift[dir, 1], shift[dir, 2]].isWall or Event(10 + 60 * Ord(sx * sy = 0)) do
        begin
//          Sleep(10000);
          if Event(40) then
            inc(Dir)
          else if Event(80) then
            Dec(dir)
          else
            Dec(dir, 2);
//          dir := random(4);

          if dir < 0 then dir := dir + 4
          else if dir > 3 then dir := dir - 4;

          if not sensors[shift[dir, 1], shift[dir, 2]].isWall then
            Break;
        end;

        if dir < 0 then
          Inc(dir, 4)
        else if dir > 3 then
          Dec(dir, 4);

        result.actionType := diract[dir];
        Inc(sx, shift[dir, 1]);
        Inc(sy, shift[dir, 2]);
        end;
      end;
    3: //  
      begin
        if Abs(sx) + Abs(sy) = 1 then
        begin
          result.actionType := aaPut;
          state := 2;
        end
        else
        begin
          if Abs(sx) < Abs(sy) then
          begin
            if sy < 0 then
              dir := 3
            else
              dir := 1;
          end
          else if sx < 0 then
            dir := 0
          else
            dir := 2;

          result.actionType := diract[dir];
          Inc(sx, shift[dir, 1]);
          Inc(sy, shift[dir, 2]);
        end;
      end;
  end;
  end;

  memory^[0] := sx + 128;
  memory^[1] := sy + 128;
  memory^[2] := state;
  memory^[3] := number;
  memory^[4] := dir;
  memory^[10] := ex + 128;
  memory^[11] := ey + 128;
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
end.
