(*------------------------------------------------------------
TEAM08
A
173
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library OSPU_2;
uses
  Math,
  Ants in 'Ants.pas';

const
  PLAYER_NAME = 'OSPU_2';


procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;
var
  bited: boolean;
  h: integer;

procedure Bite;
begin
  bited := false;
  if sensors[0, -1].isEnemy then
  begin
    bited := true;
    result.actionType := aaBiteUp;
  end;
  if sensors[0, 1].isEnemy then
  begin
    bited := true;
    result.actionType := aaBiteDown;
  end;
  if sensors[1, 0].isEnemy then
  begin
    bited := true;
    result.actionType := aaBiteRight;
  end;
  if sensors[-1, 0].isEnemy then
  begin
    bited := true;
    result.actionType := aaBiteLeft;
  end;
end;
  
procedure BiteHome;
var
  l, u, d, r: boolean;
begin
    l:= sensors[-1, 0].isWall;
    u := sensors[0, -1].isWall;
    r := sensors[1, 0].isWall;
    d := sensors[0, 1].isWall;

    if u and l then
      result.actionType := aaMoveRight
    else
          if u and r then
          result.actionType := aaMoveDown
          else
            if r and d then
            result.actionType := aaMoveLeft
            else
              if d and l then
              result.actionType := aaMoveUp
         else
          if u and l then
          result.actionType := aaMoveRight
        else
              if u then result.actionType := aaMoveRight
              else if r then  result.actionType := aaMoveDown
                else if d then  result.actionType := aaMoveLeft
                  else if l then result.actionType := aaMoveUp;
      Bite;            
      if sensors[0, 0].isEnemyHill then
      begin
        case memory[2] of
          0: if not(sensors[0, -1].isWall) then result.actionType := aaBiteUp
             else
               result.actionType := aaBiteDown;
          1: if not(sensors[0, 1].isWall) then result.actionType := aaBiteDown
             else
               result.actionType := aaBiteUp;
          2: if not(sensors[1, 0].isWall) then result.actionType := aaBiteRight
             else
               result.actionType := aaBiteLeft;
          3: if not(sensors[-1, 0].isWall) then result.actionType := aaBiteLeft
             else
               result.actionType := aaBiteRight;

        end;
        memory[2] := (memory[2]+1) mod 4;
       end;
end;


procedure SearchFood;
var
  i, j, minsmell, mini, minj, k: integer;
  found: boolean;
begin
  minsmell := 110;
  mini := 1;
  minj := 0;
  found := false;
  k := random(15);
  if sensors[0, 0].isFood and not(sensors[0, 0].isMyHill) then
  begin
      found := true;
      result.actionType := aaGet
  end
  else
    for i := -1 to 1 do
      for j := -1 to 1 do
      begin
        if (sensors[j, i].smellIntensity < minsmell) and not(sensors[j,i].isWall) then
        begin
          minsmell := sensors[j, i].smellIntensity;
          mini := i;
          minj := j;
        end;

        if (sensors[j, i].isFood)and not(sensors[i, j].isMyHill) then
        begin
          found := true;
          if i*j = 0 then
          begin
           if i = -1 then
             result.actionType := aaMoveUp
           else if i = 1 then
             result.actionType := aaMoveDown
             else if j = -1 then
              result.actionType := aaMoveLeft
               else result.actionType := aaMoveRight;
          end
          else
          begin
            if i = -1 then
              result.actionType:= aaMoveUp
            else
              result.actionType:= aaMoveDown;
          end;
        end;
      end;

      if not(found) and not(bited) then
      begin
         if mini*minj = 0 then
          begin
           if mini = -1 then
             result.actionType := aaMoveUp
           else if mini = 1 then
             result.actionType := aaMoveDown
             else if minj = -1 then
              result.actionType := aaMoveLeft
               else if minj = 1 then
                result.actionType := aaMoveRight;
          end
          else
          begin
            if mini = -1 then
              result.actionType:= aaMoveUp
            else
              result.actionType:= aaMoveDown;
          end;



      if k = 0 then
        result.actionType := aaMoveUp;
      if k = 1 then
        result.actionType := aaMoveLeft;
      if k = 2 then
        result.actionType := aaMoveDown;
      if k = 3 then
        result.actionType := aaMoveRight;
      end;

end;

procedure GoHome;
var
  u, l, r, d: boolean;
begin
  result.actionType := aaMoveLeft;

  if sensors[0, 0].isMyHill then
    result.actionType := aaPut
  else
  if not(sensors[0, 0].isWall) then
  begin

    l:= sensors[-1, 0].isWall;
    u := sensors[0, -1].isWall;
    r := sensors[1, 0].isWall;
    d := sensors[0, 1].isWall;

    if u and l then
      result.actionType := aaMoveRight
    else
          if u and r then
          result.actionType := aaMoveDown
          else
            if r and d then
            result.actionType := aaMoveLeft
            else
              if d and l then
              result.actionType := aaMoveUp
         else
          if u and l then
          result.actionType := aaMoveRight
        else
              if u then result.actionType := aaMoveRight
              else if r then  result.actionType := aaMoveDown
                else if d then  result.actionType := aaMoveLeft
                  else if l then result.actionType := aaMoveUp;
  end;


end;

procedure Steal;
var
  l, u, d, r: boolean;
begin
    l:= sensors[-1, 0].isWall;
    u := sensors[0, -1].isWall;
    r := sensors[1, 0].isWall;
    d := sensors[0, 1].isWall;

    if u and l then
      result.actionType := aaMoveRight
    else
          if u and r then
          result.actionType := aaMoveDown
          else
            if r and d then
            result.actionType := aaMoveLeft
            else
              if d and l then
              result.actionType := aaMoveUp
         else
          if u and l then
          result.actionType := aaMoveRight
        else
              if u then result.actionType := aaMoveRight
              else if r then  result.actionType := aaMoveDown
                else if d then  result.actionType := aaMoveLeft
                  else if l then result.actionType := aaMoveUp;
      if sensors[0, 0].isFood and not(hasFood) then
         result.actionType := aaGet;

      if sensors[0, 0].isMyHill and hasFood then
         result.actionType := aaPut;


end;

begin
   h := memory[4]*256 + memory[5];
   inc(h);
   if (h = 700) and (random(2) = 1) then
      memory[1] := 1;

   memory[4] := byte(h div 256);
   memory[5] := byte(h mod 256);

   if memory[0] = 0 then
     memory[0] := random(250) + 3;
   if memory[1] = 0 then
     memory[1] := random(20)+1;

   result.putSmell := true;
   result.smell := memory[0];
   if memory[1] = 1 then
   begin
     Steal;
     if hasFood then
       GoHome;
   end
   else
    if memory[1] = 2 then
    begin
      BiteHome;
    end
    else
      if  memory[1] = 3 then
      begin
        case memory[2] of
          0: if not(sensors[0, -1].isWall) then result.actionType := aaBiteUp
             else
               result.actionType := aaBiteDown;
          1: if not(sensors[0, 1].isWall) then result.actionType := aaBiteDown
             else
               result.actionType := aaBiteUp;
          2: if not(sensors[1, 0].isWall) then result.actionType := aaBiteRight
             else
               result.actionType := aaBiteLeft;
          3: if not(sensors[-1, 0].isWall) then result.actionType := aaBiteLeft
             else
               result.actionType := aaBiteRight;

        end;
        memory[2] := (memory[2]+1) mod 4;
        end
      else
         begin
             if hasFood then
               begin
                 Bite;
                 GoHome
               end
             else
             begin
               if  sensors[0, 0].isMyHill or sensors[-1, 0].isMyHill then
                 result.actionType := aaMoveRight
               else
                 begin
                    if random(2) = 1 then Bite;
                   SearchFood;
                 end;
             end;
         end;
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;

begin
  randomize;
end.

