/*------------------------------------------------------------
TEAM12
A
156
Target: AntsCpp; Platform: Win32; Comment: MS Visual C++ 6 (Ants, dll)
------------------------------------------------------------*/
#include "windows.h"
#include "Ants.h"
#include <math.h>
#include <stdlib.h>

#define PLAYER_NAME "TyumenSU#1"

char sosed[4][2]={{0,1},{-1,0},{0,-1},{1,0}};

AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY])
{
	AntAction result;
	result.actionType=MOVE_LEFT;

/*	if (hasFood && sensors[1][1].isMyHill) result.actionType = PUT;
	else if (!hasFood && !sensors[1][1].isMyHill && sensors[1][1].isFood) result.actionType = GET;
	else
	{
		char spiralSize = max(10, memory[0]);
		char position = memory[1];
		char direction = memory[2];
		position = position % spiralSize;
		if (position == 0)
		{
			if (direction == 3) spiralSize = max(10, (spiralSize + 1) % 41);
			direction = (direction + 1) % 4;
		}
		position++;
		memory[0] = spiralSize;
		memory[1] = position;
		memory[2] = direction;
		result.actionType = AntActionType(direction);
	}
*/	

	if (memory[0] != 1 && memory[0] != 2)
	{
		if (rand() % 10 == 0)
		{
			memory[0] = 1;//guard
		}
		else
		{
			memory[0] = 2;
			memory[4] = rand() % 200 - 100;
			memory[5] = rand() % 200 - 100;
			if (abs(memory[4]) < 10) memory[4] *= 5;
			if (abs(memory[5]) < 10) memory[5] *= 5;
		}
		memory[1] = memory[2] = 0;
	}
	else
	{
		if (memory[0] == 1)
		{
			int i;
			for (i=0;i<4;i++)
				if (sensors[1+sosed[i][0]][1+sosed[i][1]].isEnemy)
				{
					result.actionType=(AntActionType)(i+4);//bite!!!				
					return result;
				}
			result.actionType=PUT;

		}
		else
		{
			if (hasFood)
			{
				if (sensors[1][1].isMyHill)
				{
					result.actionType=PUT;
				}
				else if (abs(memory[1])>abs(memory[2]))
				{
					if (memory[1]<0)
						result.actionType=MOVE_RIGHT;
					else
						result.actionType=MOVE_LEFT;
				}
				else
				{
					if (memory[2]<0)
						result.actionType=MOVE_UP;
					else
						result.actionType=MOVE_DOWN;
				}
			}
			else
			{
				if (!sensors[1][1].isMyHill && sensors[1][1].isFood)
				{
					result.actionType=GET;
				}
				else
				{
					int i,j,k = rand()&3;
					int mini=-1;
					for (j=0;j<4;j++)
					{
						i = (j+k)&3;
						if(sensors[1+sosed[i][0]][1+sosed[i][1]].isEnemy)
						{
							if(rand()&1)
							{
								mini = -2;
								result.actionType = (AntActionType)(4+i);
								break;
							}
							else
							{
								i++;
								memory[5-(i&1)] = abs(memory[5-(i&1)])*(1-2*(i/2));
								continue;
							}

						}
						if (sensors[1+sosed[i][0]][1+sosed[i][1]].isWall)
						{							
							memory[5-(i&1)] = abs(memory[5-(i&1)])*(1-2*(i/2));
							continue;
						}
					}
					if (mini==-1)
					{
						k = rand() % (1 + abs(memory[4]) + abs(memory[5]));
						if(k < abs(memory[4]))
							result.actionType = (memory[4] > 0)?MOVE_RIGHT:MOVE_LEFT;
						else
							result.actionType = (memory[5] > 0)?MOVE_UP:MOVE_DOWN;
						if(sensors[1+sosed[mini][0]][1+sosed[mini][1]].isWall)
						{
							switch (result.actionType)
							{
							case MOVE_DOWN:
									memory[5] *= -1;
									result.actionType=MOVE_UP;
									break;
								case MOVE_RIGHT:
									memory[4] *= -1;
									result.actionType=MOVE_LEFT;
									break;
								case MOVE_UP:
									memory[5] *= -1;
									result.actionType=MOVE_DOWN;
									break;
								case MOVE_LEFT:
									memory[4] *= -1;
									result.actionType=MOVE_RIGHT;
									break;
							}
						}
					}
					else
					switch (mini)
					{
					case 0:
							result.actionType=MOVE_UP;
							break;
						case 1:
							result.actionType=MOVE_LEFT;
							break;
						case 2:
							result.actionType=MOVE_DOWN;
							break;
						case 3:
							result.actionType=MOVE_RIGHT;
							break;
						  						
					}
					
				}
			}
		}
	}
	switch(result.actionType)
	{
	case MOVE_UP:
		memory[2]++;
		break;
	case MOVE_LEFT:
		memory[1]--;
		break;
	case MOVE_DOWN:
		memory[2]--;
		break;
	case MOVE_RIGHT:
		memory[1]++;
	}

	result.putSmell=true;
	result.smell=rand() % 100;
	return result;
}

char* __stdcall GetName()
{
	return PLAYER_NAME;
}
