(*------------------------------------------------------------
TEAM13
A
179
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
library PermSTU1;
uses
  Math,
  Ants in '..\Ants.pas';

const
  PLAYER_NAME = 'PermSTU1';

function GetDir(x0, y0, x,y: integer): TAntActionType;
begin
  if x = x0 + 1      then result := aaMoveRight
  else if x = x0 - 1 then result := aaMoveLeft
  else if y = y0 + 1 then result := aaMoveDown
  else if y = y0 - 1 then result := aaMoveUp
  else Result :=  aaBiteUp;
end;


var dx, dy : integer;
    n: integer;

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory:
                             PMemory; var result: TAntAction); stdcall;
  var x0, y0, x,y: integer;
  procedure Init;
    BEGIN
     inc(n);
     memory^[0] := 100;
     memory^[1] := 100;
     If sensors[-1][0].isWall
       Then
        dx := 1
       ELSE
        dx := -1;
     If sensors[0][-1].isWall
       Then
        dy := 1
       ELSE
        dy := -1;

     memory^[3] := dx + 2;
     memory^[4] := dy + 2;

     memory^[5] := n;
  END;

  function Bite(var r: TAntAction): boolean;
  begin
     if (memory^[2] <> 0 ) then
     begin
       Bite:=false;
       memory^[2] := 0;
       exit;
     end;
     Bite := true;
     if sensors[-1][0].isEnemy then
     begin
        r.actionType := aaBiteLeft;
        memory^[2] := 1;
        exit;
     end;
     if sensors[1][0].isEnemy then
     begin
        r.actionType := aaBiteRight;
        memory^[2] := 1;
        exit;
     end;
     if sensors[0][-1].isEnemy then
     begin
        r.actionType := aaBiteUp;
        memory^[2] := 1;
        exit;
     end;
     if sensors[0][1].isEnemy then
     begin
        r.actionType := aaBiteDown;
        memory^[2] := 1;
        exit;
     end;
     Bite := false;
  end;

  procedure Food(var r: TAntAction);
  begin
     if x<>100 then x:=x-dx
     else y := y-dy;

     r.putSmell := true;
     r.smell    := 1;

     r.actionType    := GetDir(x0,y0,x,y);
  end;

  procedure Go(var r: TAntAction);
  begin
   if memory^[5] = 17 then
   begin
     if sensors[0][0].isMyHill then x := x + dx;
     exit;
   end;
   if memory^[5] = 18 then
   begin
     if sensors[0][0].isMyHill then  y := y + dy;
     exit;
   end;

   if sensors[memory^[3]-2][0].isWall  then
      memory^[3]:=2-(memory^[3]-2);
    if sensors[0][memory^[4]-2].isWall  then
       memory^[4]:=2-(memory^[4]-2);

    if random(2) = 0  then
    BEGIN
        x := x + memory^[3] - 2;
    END
    ELSE   BEGIN
        y := y + memory^[4] - 2;
    END;

  end;

begin

  IF memory^[0] = 0 THEN
  begin
    init;
  end;
  result.putSmell := true;
  result.smell := 1000;
  x0 := memory^[0];
  y0 := memory^[1];
  x:=x0;
  y:=y0;

  if Bite(result) then exit;

  if hasFood and sensors[0][0].isMyHill then
  begin
      result.actionType := aaPut;
      exit;
  end;

  if hasFood then begin
    Food(result);
    memory^[0]:=x;
    memory^[1]:=y;
    exit;
  end;

  if sensors[0][0].isFood and not sensors[0][0].isMyHill then
  begin
    result.actionType :=  aaGet;
    exit;
  end;

  Go(result);

  memory^[0]:=x;
  memory^[1]:=y;

  result.actionType  := GetDir(x0,y0,x,y);
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
     randomize;
     n := 0;
end.
