(*------------------------------------------------------------
TEAM26
A
180
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library OsuTeam;
uses
  Math,
  Ants in 'Ants.pas';

const
  PLAYER_NAME = 'OSU - RULES';
  Ukus = 10000; Vrag = 2; Eda = 3; smellstrag = 5;
  home = 3; strag = 4; step = 6;

var
  stragset:boolean;
function GoHome(memory:Pmemory;sensors:TSensors):byte;
begin
  if (memory[home] = 1) then
    if sensors[0,-1].isWall then
      GoHome:=1
    else
      GoHome:=0;
  if (memory[home] = 2) then
    if sensors[0,-1].isWall then
      GoHome:=3
    else
      GoHome:=0;
  if (memory[home] = 3) then
  if sensors[0,1].isWall then
    GoHome:=1
  else
    GoHome:=2;
  if (memory[home] = 4) then
  if sensors[0,1].isWall then
    GoHome:=3
  else
    GoHome:=2;

end;

function GetVect(i,j:integer):integer;
begin
  if (i = -1)and(j = 0) then GetVect:=1;
  if (i = 1)and(j = 0) then GetVect:=3;
  if (i = 0)and(j = 1) then GetVect:=2;
  if (i = 0)and(j = -1) then GetVect:=0;

end;

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;
var
  spiralSize: Byte;
  position: Byte;
  direction: Byte;
  max, i, j, im, jm:integer;

begin
  if (stragset) then
    memory[strag]:= 2;
  if (stragset = false) then
  begin
    memory[strag]:= 1;
    result.putSmell:=true;
    result.smell:= smellstrag;
    stragset:=true;
  end;

  if sensors[0,0].isMyHill and sensors[-1,0].isWall and sensors[0,-1].isWall then memory[home]:= 1;
  if sensors[0,0].isMyHill and sensors[1,0].isWall and sensors[0,-1].isWall then memory[home]:= 2;
  if sensors[0,0].isMyHill and sensors[1,0].isWall and sensors[0,1].isWall then memory[home]:= 4;
  if sensors[0,0].isMyHill and sensors[-1,0].isWall and sensors[0,1].isWall then memory[home]:= 3;

  result.putSmell:=false;
  if sensors[-1,0].isEnemy and ((sensors[0,0].smell <> ukus) or (sensors[0,0].smellIntensity <94)) then begin
    result.actionType := aaBiteLeft;
    result.putSmell := true;
    result.smell:= Ukus;
    end else
  if sensors[1,0].isEnemy and ((sensors[0,0].smell <> ukus) or (sensors[0,0].smellIntensity <94)) then begin
    result.actionType := aaBiteRight;
    result.putSmell := true;
    result.smell:= Ukus;end else
  if sensors[0,1].isEnemy and ((sensors[0,0].smell <> ukus) or (sensors[0,0].smellIntensity <94)) then begin
    result.actionType := aaBiteDown;
    result.putSmell := true;
    result.smell:= Ukus; end else
  if sensors[0,-1].isEnemy and ((sensors[0,0].smell <> ukus) or (sensors[0,0].smellIntensity <94)) then begin
    result.actionType := aaBiteUp;
    result.putSmell := true;
    result.smell:= Ukus;
  end else
  if (memory[strag] = 2) then 
  if hasFood and sensors[0][0].isMyHill then result.actionType := aaPut
  else if hasFood then result.actionType:= TAntActionType(GoHome(memory,sensors)) else
  if not sensors[0][0].isMyHill and sensors[0][0].isFood then result.actionType := aaGet
  else
  begin
    max:=110;
    im:=0;
    jm:=0;
    case memory[home] of
    1:begin
      im:=random(2);
      jm:=random(2);
      while (abs(im)= abs(jm))  do begin
        im:=random(2);
        jm:=random(2);
      end;
      end;
    2:begin
        im:=random(2)-1;
        jm:=random(2);
        while (abs(im)= abs(jm))  do begin
          im:=random(2)-1;
          jm:=random(2);
        end;
        end;
    3:begin
        im:=random(2);
        jm:=random(2)-1;
      while (abs(im)= abs(jm))  do begin
          im:=random(2);
          jm:=random(2)-1;
        end;
      end;
    4:begin
        im:=random(2)-1;
        jm:=random(2)-1;
      while (abs(im)= abs(jm))  do begin
          im:=random(2)-1;
          jm:=random(2)-1;
        end;
      end;
    end;

    if not sensors[im,jm].isWall then  result.actionType:= TAntActionType(GetVect(im,jm));
    result.putSmell:=true;
    result.smell:=step;
//    result.
    {spiralSize := Max(10, memory[0]);
    position := memory[1];
    direction := memory[2];
    position := position  mod spiralSize;
    if position = 0 then
    begin
      if direction = 3 then spiralSize := Max(10, (spiralSize + 1) mod 41);
      direction := (direction + 1) mod 4;
    end;
    Inc(position);
    memory[0] := spiralSize;
    memory[1] := position;
    memory[2] := direction;
    result.actionType := TAntActionType(direction);{}
  end;

end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
stragset:=false;
end.
