/*------------------------------------------------------------
TEAM47
A
37
Target: AntsCpp; Platform: Win32; Comment: MS Visual C++ 6 (Ants, dll)
------------------------------------------------------------*/
#include "windows.h"
#include "Ants.h"
#include <math.h>

#define PLAYER_NAME "CppSample"

AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY])
{
	AntAction result;
	if (hasFood && sensors[1][1].isMyHill) result.actionType = PUT;
	else if (!hasFood && !sensors[1][1].isMyHill && sensors[1][1].isFood) result.actionType = GET;
	else
	{
		char spiralSize = max(10, memory[0]);
		char position = memory[1];
		char direction = memory[2];
		position = position % spiralSize;
		if (position == 0)
		{
			if (direction == 3) spiralSize = max(10, (spiralSize + 1) % 41);
			direction = (direction + 1) % 4;
		}
		position++;
		memory[0] = spiralSize;
		memory[1] = position;
		memory[2] = direction;
		result.actionType = AntActionType(direction);
	}
	return result;
}

char* __stdcall GetName()
{
	return PLAYER_NAME;
}
