//    
enum AntActionType{
	// :
	MOVE_UP = 0,
	MOVE_LEFT = 1,
	MOVE_DOWN = 2,
	MOVE_RIGHT = 3,
	// :
	BITE_UP = 4,
	BITE_LEFT = 5,
	BITE_DOWN = 6,
	BITE_RIGHT = 7,
	//   :
	GET = 8,
	PUT = 9,
};
//       
struct AntAction
{
    AntActionType actionType; // ,     
    bool putSmell; //     
    int smell; //    
};

//  .  .
struct InteropAntAction
{
    char actionType;
    bool putSmell;
    int smell;
};

//    .
//         
struct AntSensor{
    int smell; //  
    int smellIntensity; //  
    bool isFriend; //  "" 
    bool isEnemy; //  "" 
    bool isMyHill; //  "" 
    bool isEnemyHill; //  "" 
    bool isFood; //  
    bool isWall; //  
};
const int MAX_MEMORY = 32; //    

AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY]);

//  .  .
void __stdcall GetAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY], InteropAntAction* antAction)
{
	AntAction result = GetAntAction(sensors, hasFood, memory);
	antAction->putSmell = result.putSmell;
	antAction->smell = result.smell;
	antAction->actionType = (char)result.actionType;
}
