unit Ants;

interface
const
  MAX_MEMORY = 32; //    
type
  //    
  TAntActionType = (
    aaMoveUp, aaMoveLeft, aaMoveDown, aaMoveRight, // 
    aaBiteUp, aaBiteLeft, aaBiteDown, aaBiteRight, // 
    aaGet, aaPut); //   

  //    .
  //         
  TAntSensor = record
    smell: Integer; //  
    smellIntensity: Integer; //  
    isFriend: Boolean; //  "" 
    isEnemy: Boolean; //  "" 
    isMyHill: Boolean;  //  "" 
    isEnemyHill: Boolean;  //  "" 
    isFood: Boolean; //  
    isWall: Boolean; //  
  end;

  //       
  TAntAction = record
    actionType: TAntActionType; // ,     
    putSmell: Boolean; //     
    smell: Integer; //    
  end;

  //       9   .
  // sensors[-1, -1] -      
  // sensors[1, -1] -      
  // sensors[1, 1] -      
  //  ..
  TSensors = array[-1..1, -1..1] of TAntSensor;

  //  
  PMemory = ^TMemory;
  TMemory = array[0..MAX_MEMORY-1] of Byte;

implementation

end.
