(*------------------------------------------------------------
TEAM01
A
172
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library DelphiSamplePlayer;
uses
  Math,
  Ants in 'Ants.pas';

const
  PLAYER_NAME = 'GOFF-NO';

type
  Byte = ShortInt;

var
  Count: LongInt;

Type
  PMyMemory = ^TMemory;
  TMyMemory = array[0..MAX_MEMORY-1] of Byte;

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMyMemory; var result: TAntAction); stdcall;
var
  spiralSize: Byte;
  position: Byte;
  direction: Byte;
  i, X, Y, PX, PY :longint;
  Ok : boolean;
begin
  if (memory^[10]=0) then
  Begin
    Inc(Count);
    memory^[10]:=1;
    if (Count<2) then memory^[10]:=2
  End;

   if (memory^[8]=0) then
   Begin
     if (memory^[8]>0) then memory^[8]:=memory^[8]-1;
   if (sensors[-1][0].isEnemy)
   then
   BEgin
    result.actionType:=TAntActionType(5);
    memory^[8]:=8;
    Exit;
   End;
   if (sensors[+1][0].isEnemy)
   then
   BEgin
    result.actionType:=TAntActionType(7);
    memory^[8]:=8;
    Exit;
   End;
   if (sensors[0][+1].isEnemy)
   then
   BEgin
    result.actionType:=TAntActionType(6);
    memory^[8]:=8;
    Exit;
   End;
   if (sensors[0][-1].isEnemy)
   then
   BEgin
    result.actionType:=TAntActionType(4);
    memory^[8]:=8;
    Exit;
   End;

   if (memory^[10]=2) then
   Begin
    result.actionType:=TAntActionType(5);
    Exit;
   End;

  End;

  if (sensors[0][0].isMyHill) then
  begin
    if not hasFood then
    Begin
      fillchar(memory^, sizeof(TMemory), 0);
      memory^[0]:= random(14);
      memory^[1]:= random(14);
    End;
  end;

  if hasFood and sensors[0][0].isMyHill then result.actionType := aaPut
  else if not hasFood and not sensors[0][0].isMyHill and sensors[0][0].isFood then
  Begin
    result.actionType := aaGet;
    memory^[11]:=-memory^[2]; memory^[12]:=-memory^[3];
  End
  else
  if HasFood then
  begin
    repeat
    X:=memory^[2]; Y:=memory^[3]; Ok:=true;
    if (X>0)and(Ok)and(random(3)<1) then
    Begin
      result.actionType:=TAntActionType(1);
      Dec(X);
      Ok:=false;
    End;
    if (X<0)and(Ok)and(random(3)<1) then
    Begin
      result.actionType:=TAntActionType(3);
      Inc(X);
      Ok:=false;
    End;
    if (Y>0)and(Ok)and(random(3)<1) then
    Begin
      result.actionType:=TAntActionType(0);
      Dec(Y);
      Ok:=false;
    End;
    if (Y<0)and(Ok)and(random(3)<1) then
    Begin
      result.actionType:=TAntActionType(2);
      Inc(Y);
      Ok:=false;
    End;
    until not ok;
    memory^[2]:=X; memory^[3]:=Y;
  end
  else
  begin

  if (abs(Memory^[11]) + abs(Memory^[12]) > 0 )and(not HasFood) then
  Begin
    repeat
    X:=memory^[11]; Y:=memory^[12]; Ok:=true;
    if (X>0)and(Ok)and(random(3)<1) then
    Begin
      result.actionType:=TAntActionType(1);
      dec(memory^[2]);
      Dec(X);
      Ok:=false;
    End;
    if (X<0)and(Ok)and(random(3)<1) then
    Begin
      result.actionType:=TAntActionType(3);
      Inc(memory^[2]);
      Inc(X);
      Ok:=false;
    End;
    if (Y>0)and(Ok)and(random(3)<1) then
    Begin
      result.actionType:=TAntActionType(0);
      Dec(memory^[3]);
      Dec(Y);
      Ok:=false;
    End;
    if (Y<0)and(Ok)and(random(3)<1) then
    Begin
      result.actionType:=TAntActionType(2);
      Inc(memory^[3]);
      Inc(Y);
      Ok:=false;
    End;
    until not ok;
    memory^[12]:=X; memory^[12]:=Y;
   Exit;
  End;

      PX:= memory^[4]; PY:= memory^[5];
      repeat
      memory^[4]:=memory^[2]; memory^[5]:=memory^[3];
      i:=2*(byte(Random(15)>= memory^[0])) + (byte(Random(15)>= memory^[1]));
      Ok:=true;
      case i of
      0:
       begin
         x:=0; Y:=-1;
       end;
      1:
       begin
         x:=-1; Y:=0;
       end;
      2:
       begin
         x:=0; Y:=+1;
       end;
      3:
       begin
         x:=+1; Y:=0;
       end;
      end;
      if (Sensors[X][Y].isWall) then Ok:=false;
      if (not ok) then
      Begin
       memory^[0]:=random(14);
       memory^[1]:=random(14);
      End;
     until (ok)and((PX<>memory^[4]+X)or(PY<>memory^[5]+Y));
    result.actionType:=TAntActionType(i);
    memory^[2]:=memory^[2] + X; memory^[3]:=memory^[3] + Y;
  end;
  result.putSmell := true;
  result.smell:=random(100);
end;

function GetName: PChar; stdcall;
begin
  Randomize;
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
end.
