/*------------------------------------------------------------
TEAM03
A
175
Target: AntsCpp; Platform: Win32; Comment: MS Visual C++ 6 (Ants, dll)
------------------------------------------------------------*/
#include "windows.h"
#include "Ants.h"
#include <math.h>

#define PLAYER_NAME "TEAM03"

AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY])
{
	AntAction result;

	if(memory[0]==0) // first step
	{	int smell=sensors[1][1].smell;
		bool w;
		w=sensors[2][0].isWall;
		if(!w) memory[7]=3;
		w=sensors[2][2].isWall;
		if(!w) memory[7]=1;
		w=sensors[0][2].isWall;
		if(!w) memory[7]=2;
		w=sensors[0][0].isWall;
		if(!w) memory[7]=4;
		memory[0]=(BYTE)smell+1;
		result.putSmell=true;
		result.smell=smell+1;
		memory[2]=1;
		switch(memory[7])
		{	case 1: if(memory[0]%2) { result.actionType=MOVE_RIGHT; memory[3]++; }
					else			{ result.actionType=MOVE_DOWN; memory[4]--; } break;
			case 2: if(memory[0]%2) { result.actionType=MOVE_LEFT; memory[3]--; }
					else			{ result.actionType=MOVE_DOWN; memory[4]--; } break;
			case 3: if(memory[0]%2) { result.actionType=MOVE_RIGHT; memory[3]++; }
					else			{ result.actionType=MOVE_UP; memory[4]++; } break;
			case 4: if(memory[0]%2) { result.actionType=MOVE_LEFT; memory[3]--; }
					else			{ result.actionType=MOVE_UP; memory[4]++; } break;
		}
		return result;
	}
	if(memory[2]==1)
	{	int smell=sensors[1-memory[3]][1+memory[4]].smell+1;
		memory[1]=(char)smell;
		switch(memory[7])
		{	case 1: memory[5]=0; memory[6]=smell*2; break;
			case 2: memory[5]=smell*2; memory[6]=smell*2; break;
			case 3: memory[5]=0; memory[6]=0; break;
			case 4: memory[6]=0; memory[5]=smell*2; break;
		}
		if((BYTE)memory[0]<4)
		{	switch(memory[7])
			{	case 1: if(!(memory[0]%2)) { result.actionType=MOVE_RIGHT; memory[3]++; }
						else			{ result.actionType=MOVE_DOWN; memory[4]--; } break;
				case 2: if(!(memory[0]%2)) { result.actionType=MOVE_LEFT; memory[3]--; }
						else			{ result.actionType=MOVE_DOWN; memory[4]--; } break;
				case 3: if(!(memory[0]%2)) { result.actionType=MOVE_RIGHT; memory[3]++; }
						else			{ result.actionType=MOVE_UP; memory[4]++; } break;
				case 4: if(!(memory[0]%2)) { result.actionType=MOVE_LEFT; memory[3]--; }
						else			{ result.actionType=MOVE_UP; memory[4]++; } break;
			}
			memory[2]++;
			return result;
		}
	}
	memory[2]++;
	if(memory[2]==100) memory[2]=4;
	if((BYTE)memory[0]<4)
	{	result.actionType=BITE_UP;
		if(sensors[1][0].isEnemy) result.actionType=BITE_UP;
		if(sensors[2][1].isEnemy) result.actionType=BITE_RIGHT;
		if(sensors[1][2].isEnemy) result.actionType=BITE_DOWN;
		if(sensors[0][1].isEnemy) result.actionType=BITE_LEFT;
	}
	else
	{
		if (hasFood && sensors[1][1].isMyHill) result.actionType = PUT;
		else 
			if (!hasFood && !sensors[1][1].isMyHill && sensors[1][1].isFood) result.actionType = GET;
		else
		{
				char spiralSize = max(10, memory[10]);
				char position = memory[11];
				char direction = memory[12];
				position = position % spiralSize;
				if (position == 0)
				{
					if (direction == 3) spiralSize = max(10, (spiralSize + 1) % 41);
					direction = (direction + 1) % 4;
				}
				position++;
				memory[10] = spiralSize;
				memory[11] = position;
				memory[12] = direction;
				result.actionType = AntActionType(direction);			
			if(!hasFood&&sensors[1][1].smell!=111)
			{	if(sensors[1][0].isEnemy) { result.actionType=BITE_UP; result.putSmell=true; result.smell=111; }
				if(sensors[2][1].isEnemy) {	result.actionType=BITE_RIGHT; result.putSmell=true; result.smell=111; }
				if(sensors[1][2].isEnemy) {	result.actionType=BITE_DOWN; result.putSmell=true; result.smell=111; }
				if(sensors[0][1].isEnemy) { result.actionType=BITE_LEFT; result.putSmell=true; result.smell=111; }
			}
		}
	}

	return result;
}

char* __stdcall GetName()
{
	return PLAYER_NAME;
}
