/*------------------------------------------------------------
TEAM17
A
166
Target: AntsCpp; Platform: Win32; Comment: MS Visual C++ 6 (Ants, dll)
------------------------------------------------------------*/
#include "windows.h"
#include "Ants.h"
#include <math.h>

#define PLAYER_NAME "CppSample"

const int go[4][2]={{0,1},{1,0},{2,1},{1,2}};
const int pos[4][2]={{0,0},{0,20},{20,0},{20,20}};

int gettype(AntSensor sensors[3][3],char memory[MAX_MEMORY]){
	if (sensors[0][0].isWall){
		return 0;
	}
	if (sensors[0][2].isWall){
		return 1;
	}
	if (sensors[2][0].isWall){
		return 2;
	}
	if (sensors[2][2].isWall){
		return 3;
	}
}

AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY])
{
	AntAction result;
	if (memory[1]|| ((sensors[1][1].smell == 0) && sensors[1][1].isMyHill)){
		memory[1]=1;
		result.putSmell=1;
		result.smell=sensors[1][1].smell+1;
		int t;
		for (t=0;t<4;t++)
			if (sensors[go[t][1]][go[t][0]].isEnemy) break;
		if (t == 4) t=rand()%4;
		t+=4;
		result.actionType=(AntActionType)t;
		return result;
	}
	if (hasFood && sensors[1][1].isMyHill) result.actionType = PUT;
	else if (!hasFood && !sensors[1][1].isMyHill && sensors[1][1].isFood) result.actionType = GET;
	else
	{
		if (sensors[1][1].isMyHill) memory[0]=gettype(sensors,memory);
		if (hasFood){
			switch(memory[0]){
				case 0:
					if (!sensors[0][1].isWall) result.actionType=MOVE_LEFT;
					else result.actionType=MOVE_UP;
					break;
				case 1:
					if (!sensors[0][1].isWall) result.actionType=MOVE_RIGHT;
					else result.actionType=MOVE_UP;
					break;
				case 2:
					if (!sensors[0][2].isWall) result.actionType=MOVE_LEFT;
					else result.actionType=MOVE_DOWN;
					break;
				case 3:
					if (!sensors[0][2].isWall) result.actionType=MOVE_RIGHT;
					else result.actionType=MOVE_DOWN;
					break;
			}
		}
		else{
			int t;
			for (t=0;t<4;t++)
				if ((rand()%4 == 1) && sensors[go[t][1]][go[t][0]].isEnemy) break;
			if (t != 4) t+=4;
			else{
				for (t=0;t<4;t++)
					if (sensors[go[t][1]][go[t][0]].isFood && !sensors[go[t][1]][go[t][0]].isMyHill) break;
				if (t == 4){
					while(1){
						t=rand()%8;
						if ((t == 4) || (t == 5)){
							switch(memory[0]){
								case 0:
									t=2;
									break;
								case 1:
									t=2;
									break;
								case 2:
									t=0;
									break;
								case 3:
									t=0;
									break;				
							}
						}
						if ((t == 6) || (t == 7)){
							switch(memory[0]){
								case 0:
									t=3;
									break;
								case 1:
									t=1;
									break;
								case 2:
									t=3;
									break;
								case 3:
									t=1;
									break;
							}
						}
						if (!sensors[go[t][1]][go[t][0]].isWall) break;
					}
				}
			}
			result.actionType=(AntActionType)t;
		}
		/*
		char spiralSize = max(10, memory[0]);
		char position = memory[1];
		char direction = memory[2];
		position = position % spiralSize;
		if (position == 0)
		{
			if (direction == 3) spiralSize = max(10, (spiralSize + 1) % 41);
			direction = (direction + 1) % 4;
		}
		position++;
		memory[0] = spiralSize;
		memory[1] = position;
		memory[2] = direction;
		result.actionType = AntActionType(direction);
		*/
	}
	return result;
}

char* __stdcall GetName()
{
	return PLAYER_NAME;
}


/*

#include "windows.h"
#include "Ants.h"
#include <math.h>

#define PLAYER_NAME "TEST"

const int go[4][2]={{-1,0},{0,-1},{1,0},{0,1}};
const int pos[4][2]={{0,0},{0,20},{20,0},{20,20}};


short int numxod(char memory[MAX_MEMORY]){
	return (short int)memory;
}

int gettype(AntSensor sensors[3][3],char memory[MAX_MEMORY]){
	if (sensors[0][0].isWall){
		memory[6]=0;
		memory[7]=0;
		return 0;
	}
	if (sensors[0][2].isWall){
		memory[6]=0;
		memory[7]=20;
		return 1;
	}
	if (sensors[2][0].isWall){
		memory[6]=20;
		memory[7]=0;
		return 2;
	}
	if (sensors[2][2].isWall){
		memory[6]=20;
		memory[7]=20;
		return 3;
	}
}

int gohome(char memory[MAX_MEMORY]){
	int x1,y1,x2,y2,k,i,t;
	x1=pos[memory[3]][0];
	x2=pos[memory[3]][1];
	x2=memory[6];
	y2=memory[7];
	k=abs(x1-x2)+abs(y1-y2);
	if (k == 0) return 9;
	for (i=0;i<4;i++){
		t=abs(x1+go[i][0]-x2)+abs(y1+go[i][1]-y2);
		if (t < k){
			memory[6]+=go[i][0];
			memory[7]+=go[i][1];
			return i;
		}
	}
}

int make_move(int k,char memory[MAX_MEMORY]){
	memory[6]+=go[k][0];
	memory[7]+=go[k][1];
	return k;
}


AntAction GetAntAction1(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY]){
	AntAction result;
	int t=(memory[3]+1)%4,x=memory[6],y=memory[7];
	result.smell=0;
	if (hasFood){
		result.actionType=(enum AntActionType)gohome(memory);
		result.putSmell=0;
	}
	else{
		x+=go[t][0];
		y+=go[t][1];
		if ((x < 0) || (x > 10) || (y < 0) || (y > 10)) result.actionType=(enum AntActionType)make_move((t+1)%4,memory);
		else result.actionType=(enum AntActionType)make_move(t,memory);
		result.putSmell=0;
	}
	return result;
}


AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY])
{
	AntAction result;
	int xod=memory[0]*256+memory[1]+1;
	memory[1]=xod%256;
	memory[0]=xod/256;
	if (xod == 1){
		memory[3]=gettype(sensors,memory);
		if (sensors[1][1].smellIntensity == 0){
			result.putSmell=1;
			result.smell=0;
			result.actionType=(enum AntActionType)make_move((memory[3]+1)%4,memory);
		}
		else{
			return result;
			result.putSmell=1;
			result.smell=sensors[1][1].smell+1;
			result.actionType=(enum AntActionType)make_move((memory[3]+1)%4,memory);
		}
		return result;
	}
	if (xod == 2){
		memory[4]=sensors[1][1].smell/100;
		if (sensors[1][1].smell%100 == 10){
			memory[5]=1;
			result.putSmell=1;
			result.smell=sensors[1][1].smell+100;
			result.actionType=(enum AntActionType)make_move((memory[3]+1)%4,memory);
		}
		else{
			memory[5]=0;
			return result;//GetAntAction2(sensors,hasfood,memory,0);
		}
	}
	if (xod >= 3){
		if (memory[5] == 1) return GetAntAction1(sensors,hasFood,memory);
		else return result;//GetAntAction2(sensors,hasfood,memory);
	}
}


char* __stdcall GetName()
{
	return PLAYER_NAME;
}
*/
