/*------------------------------------------------------------
TEAM22
A
176
Target: AntsCpp; Platform: Win32; Comment: MS Visual C++ 6 (Ants, dll)
------------------------------------------------------------*/
#include "windows.h"
#include "Ants.h"
#include <math.h>

#define PLAYER_NAME "SUrSU"

AntActionType move_up(char & x, char & y)
{
	++y;
	return MOVE_UP;
}

AntActionType move_down(char & x, char & y)
{
	--y;
	return MOVE_DOWN;
}

AntActionType move_right(char & x, char & y)
{
	++x;
	return MOVE_RIGHT;
}

AntActionType move_left(char & x, char & y)
{
	--x;
	return MOVE_LEFT;
}

void update(AntSensor sensors[3][3], char memory[MAX_MEMORY], char & count, const char MAX_COUNT, const char OFFSET, char x, char y)
{
	char i,j,a,b;
	char food_x = 0;
	char food_y = 0;
	for (i=0 ; i<count ; i++)
	{
		for (a=0 ; a<3 ; a++)
		{
			for (b=0 ; b<3 ; b++)
			{
				food_x = x+a-1;
				food_y = y-b+1;
				if (!sensors[a][b].isFood && memory[OFFSET+2*i]==food_x && memory[OFFSET+2*i+1]==food_y) //   
				{
					for (j = i ; j<count-1 ; j++)
					{
						memory[OFFSET+2*j] = memory[OFFSET+2*(j+1)];
						memory[OFFSET+2*j+1] = memory[OFFSET+2*(j+1)+1];
					}
					--count;
				}
			}
		}
	}
}

void find_food(AntSensor sensors[3][3], char memory[MAX_MEMORY], char & count, const char MAX_COUNT, const char OFFSET, char x, char y)
{
	char i,j,k;
	char food_x = 0;
	char food_y = 0;
	for (i=0 ; i<3 ; i++)
	{
		for (j=0 ; j<3 ; j++)
		{
			if (sensors[i][j].isFood)
			{
				food_x = x+i-1;
				food_y = y-j+1;
				if (food_x!=0 || food_y!=0)
				//,     
				for (k=0 ; k<count ; k++)
				{
					if (memory[OFFSET+2*k]==food_x && memory[OFFSET+2*k+1]==food_y) //   
						break;
				}
				if (k==count) // 
				{
					if (count<MAX_COUNT) // 
					{
						memory[OFFSET+2*count] = food_x;
						memory[OFFSET+2*count+1] = food_y;
						++count;
					}
				}
			}
		}
	}
}

char MIN(char a, char b)
{
	return a<b?a:b;
}

char abs(char a)
{
	return a<0?-a:a;
}

char DIST(char x1, char y1, char x2, char y2)
{
	return abs(x1-x2)+abs(y1-y2);
}

AntAction GetAntAction(AntSensor sensors[3][3], bool hasFood, char memory[MAX_MEMORY])
{
	char MAX_COUNT = 13;
	char OFFSET = 6;

	AntAction result;
	result.putSmell = false;

	char i,j,food_x,food_y;
	char & number = memory[0];
	char & x = memory[1];
	char & y = memory[2];
	char & count = memory[3];
	char & direction = memory[4];
	char & his_string = memory[5];
	char dist,temp;

	if (hasFood && sensors[1][1].isMyHill) result.actionType = PUT; //   
	else if (!hasFood && !sensors[1][1].isMyHill && sensors[1][1].isFood)  //    
	{
		result.actionType = GET;
	}
	else
	{
		//
		if (number == 0)  
		{
			x=0;
			y=0;
			count=0;
			number = sensors[1][1].smell + 1;
			result.putSmell = true;
			result.smell = number;
			his_string = 2*number;
			if (sensors[1][0].isWall) his_string*=-1;
			if (sensors[0][1].isWall) direction = 1; //
			else direction = 0; //
		}

		update(sensors,memory,count,MAX_COUNT,OFFSET,x,y);
		// 
		find_food(sensors,memory,count,MAX_COUNT,OFFSET,x,y);

		// 
		
		if (number>17)
		{
		if (sensors[0][1].isEnemy)
		{
			result.actionType = BITE_LEFT;
			return result;
		}
		if (sensors[1][0].isEnemy)
		{
			result.actionType = BITE_UP;
			return result;
		}
		if (sensors[2][1].isEnemy)
		{
			result.actionType = BITE_RIGHT;
			return result;
		}
		if (sensors[1][2].isEnemy)
		{
			result.actionType = BITE_DOWN;
			return result;
		}
		}
		/*
		if (sensors[0][0].isEnemy || sensors[2][0].isEnemy || sensors[0][2].isEnemy || sensors[2][2].isEnemy)
		{
			result.actionType = BITE_LEFT;
			return result;
		}
		*/

		//
		if (number >= 20) //
		{
			result.actionType = PUT;
		}
		else //
		{
			if (hasFood) //  -   
			{
				if (y==0)
				{
					if (x>0) result.actionType = move_left(x,y);
					else result.actionType = move_right(x,y);
				}
				else
				{
					if (y>0) result.actionType = move_down(x,y);
					else result.actionType = move_up(x,y);
				}
				return result;
			}
			else  // 
			{
				//  - ,  
				if (count>0)
				{
					// 
					dist = 100;
					for (i=0 ; i<count ; i++)
					{
						temp = DIST(x,y,memory[OFFSET+2*i],memory[OFFSET+2*i+1]);
						if (temp<dist)
						{
							dist = temp;
							food_x = memory[OFFSET+2*i];
							food_y = memory[OFFSET+2*i+1];
						}
					}

					//  
					if (y==food_y)
					{
						if (x>food_x) result.actionType = move_left(x,y);
						else result.actionType = move_right(x,y);
					}
					else
					{
						if (y>food_y) result.actionType = move_down(x,y);
						else result.actionType = move_up(x,y);						
					}
				}
				else // 
				{
					if (y!=his_string) //   
					{
						if (y>his_string) result.actionType = move_down(x,y);
						else result.actionType = move_up(x,y);
					}
					else //  
					{
						if (sensors[2*direction][1].isWall) //  
						{
							direction = 1 - direction;
						}
						// 
						if (direction == 1) result.actionType = move_right(x,y);
						else result.actionType = move_left(x,y);
					}
				}
			}
		}
	}
	return result;
}

char* __stdcall GetName()
{
	return PLAYER_NAME;
}
