(*------------------------------------------------------------
TEAM25
A
179
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library RedArmy2;
uses
  Math,
  Ants in 'Ants.pas';
const
  PLAYER_NAME = 'SibSUTI Red Army';
  dc = 2888;
  dx : array[1..9] of integer = (0,-1,0,1,1, 1, 0,-1,-1);
  dy : array[1..9] of integer = (0, 1,1,1,0,-1,-1,-1, 0);
  mx = 50;
  my = 50;

function rast(x1,y1,x2,y2:integer):integer;
begin
  rast:=abs(x1-x2)+abs(y1-y2);
end;

procedure toMem(var memory:PMemory; x, y:byte);
var
 i:byte;
 ok:boolean;
begin
  ok:=true;
  i:=10;
  while (i<=30) do
  begin
    if (memory[i]=x) and (memory[i+1]=y) then ok:=false;
    i:=i+2;
  end;
  if ok then
  begin
    i:=10;
    while (i<=30) do
    begin
      if (memory[i]=0) and (memory[i+1]=0) then
      begin
        memory[i]:=x;
        memory[i+1]:=y;
      end;
      i:=i+2;
    end;
  end;
end;

procedure getFromMem(memory:Pmemory; var x,y:byte);
var
 i:integer;
begin
  i:=10;
  while (i<=30) do
  begin
    if memory[i]<>0 then
    begin
      x:=memory[i];
      y:=memory[i+1];
      exit;
    end;
    i:=i+2;
  end;
end;

procedure delFromMem(var memory:PMemory; x,y:byte);
var
 i:integer;
begin
  i:=10;
  while (i<=30) do
  begin
    if (memory[i]=x) and (memory[i+1]=y) then
    begin
      memory[i]:=0;
      memory[i+1]:=0;
    end;
    i:=i+2;
  end;
end;

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;
var
  spiralSize: Byte;
  position: Byte;
  direction: Byte;
  x,y,ii,jj,k,ex,ey,i,j,xz,yz,z:integer;
  action:TAntActionType;
  enemys:array[-1..1,-1..1] of integer;
  safe:array[-1..1,-1..1] of boolean;
  vse,isAction:boolean;
begin
  k:=0; ex:=0; ey:=0;
  fillchar(enemys,sizeof(enemys),0);
  fillchar(safe,sizeof(safe),true);
  isAction:=false;
  randomize;
  if sensors[0,0].isMyHill then
  begin
    memory[0]:=mx;
    memory[1]:=my;
    memory[9]:=0;
    if memory[4]=1 then
    begin
      memory[2]:=memory[5];
      memory[3]:=memory[6];
      memory[4]:=0;
    end else getFromMem(memory,memory[2],memory[3]);
  end;
  if (memory[7]=0) and (sensors[0,0].isMyHill) and (not sensors[0,0].isFriend) then
  begin
    memory[7]:=1;
  end;
  if (memory[7]=0) and (sensors[0,0].isEnemyHill) and (not sensors[0,0].isFriend) then
  begin
    memory[7]:=2;
  end;
  if (memory[7]=1) or (memory[7]=2) then
  begin
    if sensors[-1,0].isEnemy then action:=aaBiteLeft else
    if sensors[1,0].isEnemy then action:=aaBiteRight else
    if sensors[0,1].isEnemy then action:=aaBiteDown else
    if sensors[0,-1].isEnemy then action:=aaBiteUp else
    begin
      if memory[7]=1 then action:=aaPut else action:=aaGet;
    end;
    isAction:=true;
    result.actionType:=action;
    result.putSmell:=false;
    exit;
  end;
  for i:=-1 to 1 do
  for j:=-1 to 1 do
  begin
    if not sensors[i,j].isFood then delFromMem(memory,memory[0]+i,memory[1]+j);
    if sensors[i,j].isFood then toMem(memory,memory[0]+i,memory[1]+j);
    if sensors[i,j].isWall then safe[i,j]:=false;
    if sensors[i,j].isEnemy then
    begin
      inc(enemys[i,j]);
      if (i=1) and (j=1) then
      begin
        safe[0,1]:=false;
        safe[1,0]:=false;
      end else
      if (i=-1) and (j=-1) then
      begin
        safe[0,-1]:=false;
        safe[-1,0]:=false;
      end else
      if (i=-1) and (j=1) then
      begin
        safe[0,1]:=false;
        safe[-1,0]:=false;
      end else
      if (i=1) and (j=-1) then
      begin
        safe[0,-1]:=false;
        safe[1,0]:=false;
      end;
    end;
    if abs(i)+abs(j)=1 then
    begin
      if sensors[i,j].isEnemy then
      begin
        inc(k);
        ex:=i;
        ey:=j;
      end;
    end;
  end;
  if ((k=1) or (k=4)) and (memory[8]=0) then
  begin
    if (ex=1) then action:=aaBiteRight else
    if (ex=-1) then action:=aaBiteLeft else
    if (ey=-1) then action:=aaBiteUp else
    if (ey=1) then action:=aaBiteDown;
    memory[8]:=1;
    isAction:=true;
  end else
  if (k>1) then
  begin
    ii:=-2;
    jj:=-2;
    for i:=-1 to 1 do
    begin
      if (ii<>-2) then break;
      for j:=-1 to 1 do
      begin
        if (abs(i)+abs(j)=1) and (safe[i,j]) then
        begin
          ii:=i;
          jj:=j;
          break;
        end;
      end;
    end;
    if (ii<>-2) then
    begin
      if (ii=1) then action:=aaMoveRight else
      if (ii=-1) then action:=aaMoveLeft else
      if (jj=-1) then action:=aaMoveUp else
      if (jj=1) then action:=aaMoveDown;
      isAction:=true;
      memory[8]:=0;
    end;
  end;
  if isAction then memory[4]:=0;
  if not isAction then
  begin
    memory[8]:=0;
    if not hasFood then
    begin
      memory[9]:=0;
      memory[4]:=0;
      vse:=true;
      if (sensors[0][0].isFood) and (not sensors[0][0].isMyHill) then
      begin
        action:=aaGet;
        isAction:=true;
        vse:=true;
        memory[4]:=0;
        result.putSmell:=false;
        result.actionType:=action;
        exit;
      end;
      for i:=-1 to 1 do
      begin
        if vse then break;
        for j:=-1 to 1 do
        begin
          if (sensors[i,j].isFood) and (not sensors[i][j].isMyHill) then
          begin
            memory[2]:=x+i;
            memory[3]:=y+j;
            vse:=true;
            break;
          end;
          if memory[2]=0 then
          begin
            z:=sensors[i][j].smell;
            z:=z-dc;
            if (z>0) and (z<=6000) then
            begin
              x:=z div 50;
              y:=z mod 50;
              if (abs(x-mx)<42) and (abs(x-my)<42) then
              begin
                if ((memory[2]=0) and (memory[3]=0)) or (rast(memory[0],memory[1],memory[2],memory[3])>rast(memory[0],memory[1],x,y)) then
                begin
                  memory[2]:=x;
                  memory[3]:=y;
                end;
              end;
            end;
          end;
        end;
      end;
      if not isAction then
      begin
        if (memory[2]=0) or ((memory[0]=memory[2]) and (memory[1]=memory[3])) then
        begin
          memory[2]:=random(82)-41 + mx;
          memory[3]:=random(82)-41 + my;
        end;
        if (abs(memory[0]-memory[2])>abs(memory[1]-memory[3])) then
        begin
          if memory[0]-memory[2]>0 then action:=aaMoveLeft else action:=aaMoveRight;
        end else
        begin
          if memory[3]-memory[1]>0 then action:=aaMoveDown else action:=aaMoveUp;
        end;
        isAction:=true;
      end;
    end else
    begin
      if sensors[0][0].isMyHill then
      begin
        action:=aaPut;
        isAction:=true;
        memory[3]:=0;
        memory[2]:=0;
      end else
      begin
        if (memory[0]=memory[5]) and (memory[1]=memory[6]) and (not sensors[0,0].isFood) then
        begin
          memory[9]:=1;
        end;
        if sensors[0][0].isFood then
        begin
          memory[4]:=1;
          memory[9]:=0;
          memory[5]:=memory[0];
          memory[6]:=memory[1];
        end;
        if (abs(memory[0]-mx)>abs(memory[1]-my)) then
        begin
          if memory[0]-mx>0 then action:=aaMoveLeft else action:=aaMoveRight;
        end else
        begin
          if my-memory[1]>0 then action:=aaMoveDown else action:=aaMoveUp;
        end;
        isAction:=true;
      end;
    end;

    while (((action=aaMoveLeft) and (sensors[-1,0].isWall)) or
    ((action=aaMoveRight) and (sensors[1,0].isWall)) or
    ((action=aaMoveDown) and (sensors[0,1].isWall)) or
    ((action=aaMoveUp) and (sensors[0,-1].isWall))) do
    begin
      memory[2]:=random(82)-41 + mx;
      memory[3]:=random(82)-41 + my;
      if (abs(memory[0]-memory[2])>abs(memory[1]-memory[3])) then
      begin
        if memory[0]-memory[2]>0 then action:=aaMoveLeft else action:=aaMoveRight;
      end else
      begin
        if memory[3]-memory[1]>0 then action:=aaMoveDown else action:=aaMoveUp;
      end;
      isAction:=true;
    end;
  end;
  if memory[9]=1 then
  begin
    result.putSmell:=true;
    result.smell:=0;
  end else
  if memory[4]=1 then
  begin
    result.putSmell:=true;
    result.smell:=dc+memory[5]*50+memory[6];
  end else result.putSmell:=false;
  if action=aaMoveRight then inc(memory[0]) else
  if action=aaMoveLeft then dec(memory[0]) else
  if action=aaMoveDown then inc(memory[1]) else
  if action=aaMoveUp then dec(memory[1]);
  result.actionType:=action;
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
end.
