(*------------------------------------------------------------
TEAM40
A
175
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library Delphi2;
uses
  Math,
  Ants in 'Ants.pas';

const
  PLAYER_NAME = 'Team 40';

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;
var
  x,y, TempX, TempY : ShortInt;
  xFood, yFood : ShortInt;
  i,j,k : integer;
  bLeft, bRight, bUp, bDown, NearFear : LongBOOL;
begin
  x:=memory^[0];
  y:=memory^[1];
  xFood := memory^[2];
  yFood := memory^[3];
  if hasFood and sensors[0][0].isMyHill then result.actionType := aaPut

       else

  if not hasFood and not sensors[0][0].isMyHill and sensors[0][0].isFood then
    result.actionType := aaGet

       else

  if hasFood and not (sensors[0][0].isMyHill) then
  begin

    k:=result.smell;
    if ((k shr 16) and $FF) = 17 then
    begin
      TempX:=k shr 8 and $FF;
      TempY:=k and $FF;
      if (TempX + TempY < xFood + yFood) then
      begin
        xFood:=TempX;
        yFood:=TempY;
      end;
    end;

      i:=Random(2);
      if (x > 0) and (i=0) then result.actionType:=aaMoveLeft else
      if (x < 0) and (i=0) then result.actionType:=aaMoveRight else
      begin
        if (y > 0) then result.actionType:=aaMoveUp;
        if (y < 0) then result.actionType:=aaMoveDown;
      end;

      if (y > 0) and (i=1) then result.actionType:=aaMoveUp else
      if (y < 0) and (i=1) then result.actionType:=aaMoveDown else
      begin
        if (x > 0) then result.actionType:=aaMoveLeft;
        if (x < 0) then result.actionType:=aaMoveRight;
      end;

    if not sensors[0][0].isFood and (x = xFood) and (y = yFood) then
    begin
      xFood:=x;
      yFood:=y;
    end;
    for i:=-1 to 1 do
      for j:=-1 to 1 do
      begin
        if sensors[i][j].isFood then
          if ((0 = xFood) and (0 = yFood)) or (xFood + yFood > x + y + i + j) then
          begin
            xFood:=x + i;
            yFood:=y + j;
          end;
      end;
  end
      else
  if not hasFood then
  begin
    NearFear := sensors[-1][0].isEnemy or  sensors[1][0].isEnemy or  sensors[0][-1].isEnemy or sensors[0][1].isEnemy;
    if (memory^[7] = 0) and (NearFear) then
    begin
      if sensors[-1][0].isEnemy  then
      begin
        result.actionType:=aaBiteLeft;
        memory^[7]:=1;
      end
      else
      if sensors[1][0].isEnemy then
      begin
        result.actionType:=aaBiteRight;
        memory^[7]:=1;
      end
      else
      if sensors[0][-1].isEnemy then
      begin
        result.actionType:=aaBiteUp;
        memory^[7]:=1;
      end
      else
      if sensors[0][1].isEnemy then
      begin
        result.actionType:=aaBiteDown;
        memory^[7]:=1;
      end
    end else
    begin
      memory^[7]:=0;

      if sensors[-1][0].isFood and not sensors[-1][0].isMyHill then
        result.actionType:=aaMoveLeft else
      if sensors[1][0].isFood and not sensors[1][0].isMyHill  then
        result.actionType:=aaMoveRight else
      if sensors[0][-1].isFood and not sensors[0][-1].isMyHill  then
        result.actionType:=aaMoveUp else
      if sensors[0][1].isFood and not sensors[0][1].isMyHill  then
        result.actionType:=aaMoveDown else

      if sensors[-1][-1].isFood and not sensors[-1][-1].isMyHill  then
        result.actionType:=aaMoveLeft else
      if sensors[-1][1].isFood and not sensors[-1][1].isMyHill  then
        result.actionType:=aaMoveLeft else
      if sensors[1][-1].isFood and not sensors[1][-1].isMyHill  then
        result.actionType:=aaMoveRight else
      if sensors[1][1].isFood and not sensors[1][1].isMyHill  then
        result.actionType:=aaMoveRight else
      //      
      begin
        if not( (xFood = 0) and (yFood = 0) ) then
        begin
          if xFood > x then
            result.actionType:=aaMoveRight else
          if xFood < x then
            result.actionType:=aaMoveLeft else
          if yFood > y then
            result.actionType:=aaMoveDown else
          if yFood < y then
            result.actionType:=aaMoveUp else
          begin
            xFood:=0; yFood:=0;
            i:=Random(2);
            if (i = 0) then
            begin
              if (x > 0) or (sensors[-1][0].isWall) then  result.actionType:=aaMoveRight else
              if (x < 0) or (sensors[1][0].isWall) then  result.actionType:=aaMoveLeft else
              if (y > 0) and ((sensors[-1][0].isWall) or (sensors[1][0].isWall)) then  result.actionType:=aaMoveDown else
              if (y < 0) and ((sensors[-1][0].isWall) or (sensors[1][0].isWall)) then  result.actionType:=aaMoveUp;
            end;
            if (i=1) then
            begin
              if (y > 0) or (sensors[0][-1].isWall) then  result.actionType:=aaMoveDown else
              if (y < 0) or (sensors[0][1].isWall) then  result.actionType:=aaMoveUp else
              if (x > 0) and ((sensors[0][-1].isWall) or (sensors[0][1].isWall)) then  result.actionType:=aaMoveRight else
              if (x < 0) and ((sensors[0][-1].isWall) or (sensors[0][1].isWall)) then  result.actionType:=aaMoveLeft;
            end;
          end;
        end else
        begin
            i:=Random(2);
            if (i = 0) then
            begin
              if (x > 0) or (sensors[-1][0].isWall) then  result.actionType:=aaMoveRight else
              if (x < 0) or (sensors[1][0].isWall) then  result.actionType:=aaMoveLeft else
              if (y > 0) and ((sensors[-1][0].isWall) or (sensors[1][0].isWall)) then  result.actionType:=aaMoveDown else
              if (y < 0) and ((sensors[-1][0].isWall) or (sensors[1][0].isWall)) then  result.actionType:=aaMoveUp;
            end;
            if (i=1) then
            begin
              if (y > 0) or (sensors[0][-1].isWall) then  result.actionType:=aaMoveDown else
              if (y < 0) or (sensors[0][1].isWall) then  result.actionType:=aaMoveUp else
              if (x > 0) and ((sensors[0][-1].isWall) or (sensors[0][1].isWall)) then  result.actionType:=aaMoveRight else
              if (x < 0) and ((sensors[0][-1].isWall) or (sensors[0][1].isWall)) then  result.actionType:=aaMoveLeft;
            end;
          end
      end;
    end;
  end

      else
  if hasFood and sensors[0][0].isMyHill then result.actionType := aaPut
  else
  begin
  end;
  case result.actionType of
   aaMoveUp    : y:=y-1;
   aaMoveLeft  : x:=x-1;
   aaMoveDown  : y:=y+1;
   aaMoveRight : x:=x+1;
  end;
  memory^[0]:=x;
  memory^[1]:=y;
  memory^[2] := xFood;
  memory^[3] := yFood;

  result.smell:=(17 shl 16) or (xFood shl 8) or yFood;
  result.putSmell := true;
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
end.
