(*------------------------------------------------------------
TEAM43
A
175
Target: AntsPas; Platform: Win32; Comment: Borland Delphi 6 (Ants, dll)
------------------------------------------------------------*)
library DelphiSamplePlayer;
uses
  Math,
  Ants in 'Ants.pas';

const
  PLAYER_NAME = 'DelphiSample';

procedure GetAction(sensors: TSensors; hasFood: Boolean; memory: PMemory; var result: TAntAction); stdcall;
var
  spiralSize: Byte;
  position: Byte;
  direction: Byte;
begin
  if hasFood and sensors[0][0].isMyHill then result.actionType := aaPut
  else if not hasFood and not sensors[0][0].isMyHill and sensors[0][0].isFood then result.actionType := aaGet
  else if (sensors[1][0].isEnemy) and (memory[3]=0)  then begin result.actionType := TAntActionType(8); memory[3]:=1; end
  else if (sensors[-1][0].isEnemy) and (memory[4]=0)  then begin result.actionType := TAntActionType(6); memory[4]:=1; end
  else if (sensors[0][1].isEnemy) and (memory[5]=0)  then begin result.actionType := TAntActionType(5); memory[5]:=1; end
  else if (sensors[0][-1].isEnemy) and (memory[6]=0)  then begin result.actionType := TAntActionType(7); memory[6]:=1; end
  else
  begin

    spiralSize := Max(8, memory[0]);
    position := memory[1];
    direction := memory[2];
    position := position  mod spiralSize;
    if position = 0 then
    begin
      if direction = 3 then spiralSize := Max(8, (spiralSize + 1) mod 41);
      direction := (direction + 1) mod 4;
    end;
    Inc(position);
    memory[0] := spiralSize;
    memory[1] := position;
    memory[2] := direction;
    result.actionType := TAntActionType(direction);
  end;
  result.putSmell := false;
end;

function GetName: PChar; stdcall;
begin
  result := PLAYER_NAME;
end;

exports
  GetName,
  GetAction;
begin
end.

